package com.email;

import com.apigee.flow.execution.ExecutionContext;
import com.apigee.flow.execution.ExecutionResult;
import com.apigee.flow.message.MessageContext;
import java.util.Properties;
import javax.mail.Message.RecipientType;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;

public class TriggerEmail implements com.apigee.flow.execution.spi.Execution
{
  static String FROM = null;
  static String TO = null;
  
  static String BODY = null;
  static String SUBJECT = null;
  

  static String SMTP_USERNAME = null;
  static String SMTP_PASSWORD = null;
  

  static String HOST = null;
  


  static String PORT = null;
  



  public TriggerEmail() {}
  


  public ExecutionResult execute(MessageContext context, ExecutionContext executionContext)
  {
    String[] receiverList = null;
    FROM = (String)context.getVariable("sender");
    TO = (String)context.getVariable("receiver");
    if (TO.contains(";")) {
      receiverList = TO.split(";");
    }
    
    BODY = (String)context.getVariable("body");
    SUBJECT = (String)context.getVariable("subject");
    
    SMTP_USERNAME = (String)context.getVariable("smtpUsername");
    SMTP_PASSWORD = (String)context.getVariable("smtpPassword");
    HOST = (String)context.getVariable("smtpHost");
    PORT = (String)context.getVariable("smtpPort");
    

    Properties props = System.getProperties();
    props.put("mail.transport.protocol", "smtp");
    props.put("mail.smtp.port", Integer.valueOf(Integer.parseInt(PORT)));
    



    props.put("mail.smtp.auth", "true");
    props.put("mail.smtp.starttls.enable", "true");
    props.put("mail.smtp.starttls.required", "true");
    

    Session session = Session.getDefaultInstance(props);
    Transport transport = null;
    

    try
    {
      MimeMessage msg = new MimeMessage(session);
      msg.addHeader("Content-type", "text/HTML; charset=UTF-8");
      msg.setFrom(new InternetAddress(FROM));
      
      if (receiverList != null) {
        InternetAddress[] mailAddress_TO = new InternetAddress[receiverList.length];
        for (int receiver = 0; receiver < receiverList.length; receiver++) {
          mailAddress_TO[receiver] = new InternetAddress(receiverList[receiver]);
        }
        msg.addRecipients(Message.RecipientType.TO, mailAddress_TO);
      }
      else {
        msg.setRecipient(Message.RecipientType.TO, new InternetAddress(TO));
      }
      msg.setSubject(SUBJECT, "UTF-8");
      msg.setContent(BODY, "text/html");
      

      transport = session.getTransport();
      





      transport.connect(HOST, SMTP_USERNAME, SMTP_PASSWORD);
      

      transport.sendMessage(msg, msg.getAllRecipients());
      
      context.setVariable("sendEmailSuccessMsg", context.getVariable("sendEmailSuccessMsg") + " " + TO);

    }
    catch (Exception ex)
    {

      String failureMsg = context.getVariable("sendEmailFailMsg") + " " + ex.getMessage().trim();
      context.setVariable("responseStatusDetails", failureMsg);
      



      try
      {
        transport.close();
      }
      catch (MessagingException e) {
        e.printStackTrace();
      }
    }
    finally
    {
      try
      {
        transport.close();
      }
      catch (MessagingException e) {
        e.printStackTrace();
      }
    }
    

    return ExecutionResult.SUCCESS;
  }
  
  public static void createMail() {}
}
